
"ixi lang: loading synthdefs for the project: default".postln;


/*
if testing you need to use create the SynthDescLib:
SynthDescLib(\noise);
Synth(\kick)
*/


	SynthDef(\noisekick, {arg out=0, pan=0, amp=0.3, filterfreq=30, rq=0.01;
			var env, signal, attack, noise, hpf1, hpf2;
			noise = LPF.ar(WhiteNoise.ar(2), 3000)+SinOsc.ar([filterfreq/2,filterfreq/2+4 ], pi*0.5, XLine.kr(1,0.01,4));
			//noise = PinkNoise.ar(1)+SinOsc.ar([(filterfreq)*XLine.kr(1,0.01,3), (filterfreq+4)*XLine.kr(1,0.01,3) ], pi*0.5, XLine.kr(1,0.01,4));
			//signal = signal * SinOsc.ar(1,0.75);
			hpf1 = RLPF.ar(noise, filterfreq, rq);
			hpf2 = RHPF.ar(noise, filterfreq/2, rq/4);
			env = EnvGen.kr(Env.perc(0.003, 0.00035));
			signal = (hpf1+hpf2) * env;
			//signal = CombC.ar(signal, 0.5, 0.03, 0.031)+CombC.ar(signal, 0.5, 0.03016, 0.06);
			//signal = Decay2.ar(signal, 0.5);
			signal = FreeVerb.ar(signal, 0.23, 0.15, 0.2);
			Out.ar(out, Pan2.ar(signal * amp, pan));
			//DetectSilence.ar(signal, doneAction:2);
			EnvGen.ar(Env.perc(0.0001, 0.3), doneAction: 2); 
		}).add(\default);
		
		SynthDef(\noisesnare, {arg out=0, pan=0, amp=0.3, filterfreq=40, rq=0.17;
			var env, signal, attack, noise, hpf1, hpf2;
			noise = LPF.ar(WhiteNoise.ar(4), 12000)+SinOsc.ar([filterfreq,filterfreq*2+4], pi*0.5, XLine.kr(1,0.03, 0.9)).sum;
			hpf1 = RLPF.ar(noise, filterfreq*2, rq);
			hpf2 = RHPF.ar(noise, filterfreq/2, rq/2);
			env = EnvGen.kr(Env.perc(0.003, 0.0015));
			signal = (hpf1+hpf2) * env;
			signal = CombC.ar(signal, 0.05, 0.00099, 0.001)+CombC.ar(signal, 0.05, 0.0011, 0.001);
			//signal = FreeVerb.ar(signal, 0.13, 0.1, 0.1);
			Out.ar(out, Pan2.ar(signal * amp, pan));
			EnvGen.ar(Env.perc(0.0001, 0.3), doneAction: 2); 
		}).add(\default);
		
		SynthDef(\noisehat, { arg out=0, pan=0, amp=0.1;
			var sig;
			// a release gate
			EnvGen.ar(Env.perc(0.0001, 0.3), doneAction: 2); 
			// the other env has problem with gate
			// (i.e. FAILURE n_set Node not found)
			sig = (Clip.ar(WhiteNoise.ar(5.5), -0.99, 0.99) + SinOsc.ar(9000, 0, 0.5)) * EnvGen.ar(Env.perc(0.00001, 0.001)) * amp;
			Out.ar(out, Pan2.ar(sig, pan));
		}).add(\default);
		
 
		SynthDef(\noisesinekick, {arg out=0, pan=0, amp=0.1;
			var signal, env;
			env = EnvGen.ar(Env.perc(0.01, 0.1, 1), doneAction:2);
			signal = SinOsc.ar(100, 0, amp*4);
			Out.ar(out, Pan2.ar(signal * env, pan));
		}).add(\default);

